-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Simple menu system (version 1.1a)
-- File:    glib.e
--          graphic library + mouse routines
-- Author:  Normand M. Blais
--          October 1999
-- Email:   marcel_ya@yahoo.com
-- ...............................................

include graphics.e
include get.e
include mouse.e
include sort.e

global
procedure rectangle(integer x,integer y,integer xlen,integer ylen,integer col)
    polygon(col,1,{{x,y},{x+xlen,y},{x+xlen,y+ylen},{x,y+ylen}})
end procedure

global
procedure fill_box(integer x,integer y,integer xlen,integer ylen,integer col)
    polygon(col,1,{{x,y},{x+xlen,y},{x+xlen,y+ylen},{x,y+ylen}})
end procedure

global
procedure empty_box(integer x,integer y,integer xlen,integer ylen,integer col)
    polygon(col,0,{{x,y},{x+xlen,y},{x+xlen,y+ylen},{x,y+ylen}})
end procedure

global
procedure frame(integer x,integer y,integer xlen,integer ylen,integer col)
    draw_line(col,
    {{x+1,y+1},{x+xlen-1,y+1},{x+xlen-1,y+ylen-1},{x+1,y+ylen-1},{x+1,y+1}})
end procedure

global
procedure Video()
    if not graphics_mode(18) then
    end if
end procedure

global
procedure To_text()
    if not graphics_mode(-1) then
    end if
end procedure

global
procedure pause()
    integer k
    k = wait_key()
end procedure

global
function max_len(sequence s)
    integer mx
    if length(s) = 0 then
        return 0
    end if
    mx = length(s[1])
    for i=2 to length(s) do
        if length(s[i]) > mx then
	    mx = length(s[i])
        end if
    end for
    return mx
end function

-- mouse

global integer m_pointer_on,m_init

m_pointer_on = 0 -- false by default
m_init = 0       -- false by default

global
procedure init_mouse(integer flag)
    mouse_events(flag) -- first call turn on mouse pointer
    m_pointer_on = 1
    m_init = 1
end procedure

global
procedure mouse_on()
    if m_init and not m_pointer_on then
        mouse_pointer(1)
        m_pointer_on = 1
    end if
end procedure

global
procedure mouse_off()
    if  m_init and m_pointer_on then
        mouse_pointer(0)
        m_pointer_on = 0
    end if
end procedure

global
function maxi(sequence s)
    sequence ss
    ss = sort(s)
    return ss[length(ss)]
end function


