-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Simple menu system (version 1.2)
-- File:    smenu.e
--          menu procedures and functions
-- Author:  Normand M. Blais
--          October 1999
-- Email:   marcel_ya@yahoo.com
-- ...............................................

include image.e
include font.e
include glib.e
include template.e

global constant
   BACKSPACE   = 8,
   ENTER       = 13,
   ESC         = 27,
   SPACE       = 32,
   F1          = 315,
   F2          = 316,
   F3          = 317,
   F4          = 318,
   F5          = 319,
   F6          = 320,
   F7          = 321,
   F8          = 322,
   F9          = 323,
   F10         = 324,
   HOME        = 327,
   UP_ARROW    = 328,
   PGUP        = 329,
   LEFT_ARROW  = 331,
   RIGHT_ARROW = 333,
   END         = 335,
   DOWN_ARROW  = 336,
   PGDOWN      = 337,
   INSERT      = 338,
   DELETE      = 339,
   F11         = 389,
   F12         = 390

global object  me  -- mouse event
global integer key -- keyboard input

global procedure event_loop()
    while 1 do
        me = get_mouse() -- mouse input
        if sequence(me) then
	    if and_bits(me[1], LEFT_DOWN) then
		exit
	    end if
        end if
        key = get_key()  -- keyboard input
        if key != -1 then
	    exit
        end if
    end while
end procedure

global procedure dos_shell()
    object x
    mouse_off()
    x = save_image({0,0},{639,479})
    To_text()
    system("command.com",2)
    Video()
    display_image({0,0},x)
    mouse_on()
end procedure

global constant HIGH_LIGHT_COLOR = 0
global constant M_MENU=1,M_ITEM=2

sequence str,img_sav

integer top_id,last_id,top_item,last_item

integer fnt,fg

integer TBx,TBy,TBw,TBh,
        MBx,MBy,MBw,MBh,
        SBx,SBy,SBw,SBh,
        CHw,CHh,MLBw,MIw,MIh

integer top_x,top_y,top_w,top_h

sequence mnuxs,itxs,itys
sequence dia_area
integer dx,dy,dw,dh


global procedure init_menu_par()
    -- initializes the menu parameters
    -- needs to be called first
    object junk
    TBx=0 TBy=0 TBw=639 TBh=20
    MBx=0 MBy=22 MBw=639 MBh=22
    SBx=0 SBy=459 SBw=639 SBh=20
    top_x=0  top_y=0 top_w=639  top_h=20
    fnt = load_font("tradit08.f")
    select_font(fnt)
    junk=lengths("MMMMMMMMM")
    CHw=width('W') CHh=height() MLBw=junk[1]
    MIw=0 MIh=height()+2
    set_foreground(BRIGHT_WHITE)
end procedure


global procedure dr_dialog(sequence dialog)
    -- draws a simple dialog window when needed
    -- is called automatically after a menu
    -- selection
    sequence ws
    integer ls
    ls = CHh+floor(CHh/2)
    ws={}
    for i=1 to length(dialog) do
        ws &= lengths(dialog[i])
    end for
    dh = length(dialog) * ls + 10
    dw = maxi(ws) + 8
    dx = floor((640 - dw) / 2) - 4
    dy = floor((480 - dh) / 2) - 8
    dia_area = save_image({dx,dy},{dx+dw,dy+dh})
    fill_box(dx,dy,dw,dh,BLUE)
    dx += 4 dy += 8
    for i=1 to length(dialog) do
        setx(dx)
        sety(dy+ls*(i-1))
        write(dialog[i])
    end for
end procedure

global object text_buffer -- use by dr_prompt
text_buffer={}

constant TB_KEY=1,TB_MESS=2

global procedure dr_prompt(sequence st,integer w)
    -- draws a simple prompt window
    -- for entering string informations.
    -- st=string of characters
    -- w=with in pixels
    sequence ws
    integer ls
    object junk
    mouse_off()
    ls = CHh+floor(CHh/2)
    ws={}
    ws &= lengths(st)+w
    dh = ls + 30
    dw = maxi(ws) + 8
    dx = floor((640 - dw) / 2) - 4
    dy = floor((480 - dh) / 2) - 8
    dia_area = save_image({dx,dy},{dx+dw,dy+dh})
    fill_box(dx,dy,dw,dh,BLUE)
    dx += 4 dy += 8
    setx(dx)
    sety(dy)
    junk=prompt(st,w)
    if junk[TB_KEY]=ENTER then
        text_buffer=junk[TB_MESS][length(st)+1..length(junk[TB_MESS])]
    else
        text_buffer = {}
    end if
    display_image({dx-4,dy-8},dia_area)
    mouse_on()
end procedure

global procedure dr_message(sequence st)
    -- draws a message box.
    sequence ws
    integer ls
    mouse_off()
    ls = CHh+floor(CHh/2)
    ws={}
    ws &= lengths(st)+5
    dh = ls + 30
    dw = maxi(ws) + 8
    dx = floor((640 - dw) / 2) - 4
    dy = floor((480 - dh) / 2) - 8
    dia_area = save_image({dx,dy},{dx+dw,dy+dh})
    fill_box(dx,dy,dw,dh,RED)
    dx += 4 dy += 8
    setx(dx)
    sety(dy)
    write(st)
    while get_key()=-1 do
    end while
    display_image({dx-4,dy-8},dia_area)
    mouse_on()
end procedure

global procedure dr_message2(sequence st)
    -- draws a message box.
    sequence ws
    integer ls
    mouse_off()
    ls = CHh+floor(CHh/2)
    ws={}
    ws &= lengths(st)+5
    dh = ls + 30
    dw = maxi(ws) + 8
    dx = floor((640 - dw) / 2) - 4
    dy = floor((480 - dh) / 2) - 8
    dia_area = save_image({dx,dy},{dx+dw,dy+dh})
    fill_box(dx,dy,dw,dh,RED)
    dx += 4 dy += 8
    setx(dx)
    sety(dy)
    write(st)
    key=wait_key()
    if key!='Y' and key!='y' then
        text_buffer={}
    end if
    display_image({dx-4,dy-8},dia_area)
    mouse_on()
end procedure

global function dialog_box(sequence lines)
    integer key,result
    mouse_off()
    dr_dialog(lines)
    result=0
    while 1 do
        key = get_key()
        if key = ESC then
	    exit
        elsif key = 'Y' or key = 'y' then
	   result = 1
	   exit
        end if
    end while
    display_image({dx-4,dy-8},dia_area)
    mouse_on()
    return result
end function

global procedure dr_title_bar(sequence s)
    -- draws the title bar
    -- called once
    sequence ws
    fill_box(TBx,TBy,TBw,TBh,BLUE)
    frame(TBx,TBy,TBw,TBh,WHITE)
    ws = lengths(s)
    setx(floor((TBw - ws[1]) / 2))
    sety(TBy+CHh)
    write(s)
end procedure

global procedure dr_work_space()
    -- draws the work space (optional)
    -- called once
    fill_box(0,46,639,411,CYAN)
end procedure

global procedure dr_status_bar()
    -- draws a status bar used in
    -- combination with the menus
    -- context informations are printed
    -- when a menu is highligthed using
    -- the arrows keys:up or down
    -- called once
    sequence ws
    fill_box(SBx,SBy,SBw,SBh,GREEN)
    frame(SBx,SBy,SBw,SBh,YELLOW)
    ws = lengths("F1 activates menu")
    setx(SBw-ws[1]-CHw)
    sety(SBy+CHh-1)
    write("F1 activates menu")
end procedure

global procedure dr_menu_bar()
    -- draws the bar with the menu labels
    -- called once
    integer x
    fill_box(MBx,MBy,MBw,MBh,WHITE)
    frame(MBx,MBy,MBw,MBh,0)
    x = CHw
    sety(MBy+CHh)
    itxs = repeat(0,length(MENU_BAR))
    mnuxs = repeat(0,length(MENU_BAR))
    for i=1 to length(MENU_BAR) do
        itxs[i] = x+CHw
        mnuxs[i] = x
        setx(x)
        write(MENU_BAR[i])
        x += MLBw
    end for
end procedure

global function is_m_over_menu_bar(integer mx,integer my)
    -- returns 1 if mouse over menu bar
    -- returns 0 otherwise
    if mx >= MBx and mx < MBx+TBw and
       my >= MBy and my < MBy+MBh then
        return 1
    end if
    return 0
end function


global function which_menu(integer mx)
    -- returns a menu id
    return floor(mx/MLBw)+1
end function

function which_item(integer my)
    -- returns a menu item id
    return floor((my-top_y)/MIh)+1
end function

function inside_menu(integer id,integer mx,integer my)
    -- returns 1 if inside the menu
    -- returns 0 otherwise
    integer mn,it
    mn = which_menu(mx)
    if mn = id then
        it = which_item(my)
        if it >= 1 and it <= length(MENU_ITEMS[id]) then
	    top_item = it
	    return 1
        end if
    end if
    return 0
end function


global function dr_menu(integer id)
    -- draws the menu referenced by id
    -- updates top_id
    sequence ws
    integer k
    if id < 1 or id > length(MENU_ITEMS) then
        return 0
    end if
    mouse_off()
    top_id = id
    str = MENU_ITEMS[id]
    top_x = mnuxs[id]
    top_y = MBy+MBh
    ws = {}
    for i=1 to length(str) do
        ws &= lengths(str[i])
    end for
    top_w = maxi(ws)+2*CHw
    top_h = MIh*length(str)+4
    img_sav = save_image({top_x,top_y},{top_x+top_w,top_y+top_h})
    fill_box(top_x,top_y,top_w,top_h,GREEN)
    empty_box(top_x,top_y,top_w,top_h,BRIGHT_WHITE)
    fg = foreground()
    itys = repeat(0,length(str))
    k = top_y+4
    for i=1 to length(str) do
        setx(itxs[id])
        itys[i] = k
        sety(itys[i])
        write(str[i])
        k += CHh+2
    end for
    mouse_on()
    return 1
end function

procedure restore_item(integer id,integer item)
    -- the opposite of highlight_item
    if item < 1 or id < 1  or id > length(MENU_ITEMS) or
       item > length(MENU_ITEMS[id]) then
        return
    end if
    mouse_off()
    setx(itxs[id])
    sety(itys[item])
    set_foreground(GREEN)
    write(MENU_ITEMS[id][item])
    set_foreground(fg)
    setx(itxs[id])
    sety(itys[item])
    write(MENU_ITEMS[id][item])
    mouse_on()
end procedure

procedure highlight_item(integer id,integer item)
    -- highlights a menu item
    if item <= 0 or id <= 0  or item > length(MENU_ITEMS[id]) then
        return
    end if
    mouse_off()
    setx(itxs[id])
    sety(itys[item])
    set_foreground(GREEN)
    write(MENU_ITEMS[id][item])
    setx(itxs[id])
    sety(itys[item])
    set_foreground(HIGH_LIGHT_COLOR)
    write(MENU_ITEMS[id][item])
    set_foreground(fg)
    mouse_on()
end procedure

procedure display_context(integer id, integer item)
    -- writes on status bar the comments associated with
    -- the item on the menu
    if item <= 0 or id <= 0  or item > length(MENU_ITEMS[id]) then
        return
    end if
    mouse_off()
    if last_id and last_item and last_item <= length(CONTEXT[last_id]) then
        setx(SBx+CHw)
        sety(SBy+CHh-1)
        set_foreground(GREEN)
        write(CONTEXT[last_id][last_item])
    end if
    set_foreground(fg)
    setx(SBx+CHw)
    sety(SBy+CHh-1)
    write(CONTEXT[id][item])
    last_id = id last_item = item
    mouse_on()
end procedure

procedure erase_context()
    -- erases the string context
    mouse_off()
    if last_id and last_item and last_item <= length(CONTEXT[last_id]) then
        set_foreground(GREEN)
        setx(SBx+CHw)
        sety(SBy+CHh-1)
        write(CONTEXT[last_id][last_item])
        set_foreground(fg)
    end if
    mouse_on()
end procedure

procedure close_menu(integer id)
    if id then
        mouse_off()
        display_image({mnuxs[id],top_y},img_sav)
        img_sav = {}
        mouse_on()
    end if
end procedure

global function select_menu()
    -- interacts with the keyboards
    -- or the mouse.
    -- returns a sequence of 2 elements:
    -- {menu_id,item_id}
    -- If itemid is zero, we assume that nothing is selected.
    last_id = top_id
    last_item = 0
    top_item = 1
    highlight_item(top_id,top_item)
    display_context(top_id,top_item)
    while 1 do
        event_loop()
        if key = ESC then
	    close_menu(last_id)
	    erase_context()
	    top_item = 0
	    exit
        elsif key = F1 and top_id = 0 then
	    if dr_menu(1) then -- open the menu
		top_id = 1
		top_item = 1
		last_id = 1
		last_item = 0
		highlight_item(top_id,top_item)
		display_context(top_id,top_item)
	    end if
        elsif key = UP_ARROW and top_id > 0 then
	    last_item = top_item
	    top_item -= 1
	    if top_item < 1 then
		top_item = length(str)
	    end if
	    restore_item(top_id,last_item)
	    highlight_item(top_id,top_item)
	    display_context(top_id,top_item)
        elsif key = DOWN_ARROW and top_id > 0 then
	    last_item = top_item
	    top_item += 1
	    if top_item > length(str) then
		top_item = 1
	    end if
	    restore_item(top_id,last_item)
	    highlight_item(top_id,top_item)
	    display_context(top_id,top_item)
        elsif key = LEFT_ARROW and top_id then
	    erase_context()
	    last_id = top_id
	    top_id -= 1
	    if top_id < 1 then
		top_id = length(MENU_BAR)
	    end if
	    close_menu(last_id)
	    if dr_menu(top_id) then
		top_item = 1
		last_item = 1
		highlight_item(top_id,top_item)
		display_context(top_id,top_item)
	    end if
        elsif key = RIGHT_ARROW and top_id then
	    erase_context()
	    last_id = top_id
	    top_id += 1
	    if top_id > length(MENU_BAR) then
		top_id = 1
	    end if
	    close_menu(last_id)
	    if dr_menu(top_id) then
		top_item = 1
		last_item = 1
		highlight_item(top_id,top_item)
		display_context(top_id,top_item)
	    end if
        elsif key = ENTER then
	    close_menu(last_id)
	    erase_context()
	    exit
        elsif sequence(me) then
	    if top_id then -- a menu is opened
		if inside_menu(top_id,me[2],me[3]) then
		    close_menu(last_id)
		    erase_context()
		    exit
		elsif is_m_over_menu_bar(me[2],me[3]) then
		    close_menu(last_id)
		    erase_context()
		    top_id = which_menu(me[2])
		    if dr_menu(top_id) then -- open the menu
			top_item = 1
			last_id = top_id
			last_item = 0
			highlight_item(top_id,top_item)
			display_context(top_id,top_item)
		    end if
		else -- else close the menu
		    close_menu(top_id)
		    erase_context()
		    top_id = 0
		    top_item = 0
		    last_id = 0
		    exit  --new
		end if
	    else  -- no menu is opened
		if is_m_over_menu_bar(me[2],me[3]) then
		    top_id = which_menu(me[2])
		    if dr_menu(top_id) then -- open the menu
			top_item = 1
			last_id = top_id
			last_item = 0
			highlight_item(top_id,top_item)
			display_context(top_id,top_item)
		    end if
		else      --new
		    exit  --new
		end if
	    end if
        end if
    end while
    return {top_id,top_item}
end function

